<?php

namespace Ulmus;

use Generator;

class EntityCollection extends \ArrayObject {
    
    public function filters(Callable $callback) : Generator
    {
        $idx = 0;
        
        foreach($this as $key => $item) {
            if ( $callback($item, $key, $idx) ) {
                $idx++;
                
                yield $item;
            }
        }
    }
    
    public function buildArray(string $keyColumn, string $valueColumn) : array
    {
        $list = [];
        
        foreach($this as $key => $item) {
            $list[$item->$keyColumn] = $item->$valueColumn;
        }
        
        return $list;
    }
}